/**
 * Copyright &copy; 2015-2020 <a href="http://www.jeeplus.org/">JeePlus</a> All rights reserved.
 */
package com.jeeplus.modules.test.information.entity;

import com.jeeplus.modules.sys.entity.User;
import javax.validation.constraints.NotNull;
import com.jeeplus.modules.sys.entity.Office;
import com.jeeplus.modules.sys.entity.Area;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import java.util.List;
import com.google.common.collect.Lists;

import com.jeeplus.core.persistence.DataEntity;
import com.jeeplus.common.utils.excel.annotation.ExcelField;
import com.jeeplus.modules.test.onetomany.dialog.entity.TestDataChild11;
import com.jeeplus.modules.test.onetomany.dialog.entity.TestDataChild12;
import com.jeeplus.modules.test.onetomany.dialog.entity.TestDataChild13;

/**
 * 项目信息Entity
 * @author qiuyue
 * @version 2019-09-04
 */
public class Information extends DataEntity<Information>  {
	//项目定义号
	private String projectId;
	//项目名称
	private String projectName;
	//送审部门
	private String department;
	//审定日期
	private Date approvalDate;
	//二级单位
	private String secondUnits;
	//一级单位
	private String firstUnits;

	public Information(){
		super();
	}

	public Information(String id){
		super(id);
	}

	public String getProjectId() {
		return projectId;
	}

	public void setProjectId(String projectId) {
		this.projectId = projectId;
	}

	public String getProjectName() {
		return projectName;
	}

	public void setProjectName(String projectName) {
		this.projectName = projectName;
	}

	public String getDepartment() {
		return department;
	}

	public void setDepartment(String department) {
		this.department = department;
	}

	@JsonFormat(pattern = "yyyy-MM-dd")
	public Date getApprovalDate() {
		return approvalDate;
	}

	@JsonFormat(pattern = "yyyy-MM-dd")
	public void setApprovalDate(Date approvalDate) {
		this.approvalDate = approvalDate;
	}

	public String getSecondUnits() {
		return secondUnits;
	}

	public void setSecondUnits(String secondUnits) {
		this.secondUnits = secondUnits;
	}

	public String getFirstUnits() {
		return firstUnits;
	}

	public void setFirstUnits(String firstUnits) {
		this.firstUnits = firstUnits;
	}
}