/**
 * Copyright &copy; 2015-2020 <a href="http://www.jeeplus.org/">JeePlus</a> All rights reserved.
 */
package com.jeeplus.modules.test.information.material.service;

import java.util.List;

import com.jeeplus.modules.test.information.entity.Information;
import com.jeeplus.modules.test.information.mapper.InformationMapper;
import com.jeeplus.modules.test.information.material.entity.Material;
import com.jeeplus.modules.test.information.material.mapper.MaterialMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.service.CrudService;

/**
 * 项目管理Service
 * @author
 * @version
 */
@Service
@Transactional(readOnly = true)
public class MaterialService extends CrudService<MaterialMapper, Material> {

	@Autowired
	private MaterialMapper materialMapper;

	public Material get(String id) {
		Material material = super.get(id);
		return material;
	}

	public List<Material> findList(Material material) {
		return super.findList(material);
	}

	public Page<Material> findPage(Page<Material> page, Material entity) {
		return super.findPage(page, entity);
	}

	@Transactional(readOnly = false)
	public void save(Material entity) {
		super.save(entity);
	}

	public Material findByMaterialId(Material material){
		return materialMapper.findByMaterialId(material);
	}
}