/**
 * Copyright &copy; 2015-2020 <a href="http://www.jeeplus.org/">JeePlus</a> All rights reserved.
 */
package com.jeeplus.modules.test.information.material.web;

import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.validation.ConstraintViolationException;

import com.jeeplus.modules.test.information.entity.Information;
import com.jeeplus.modules.test.information.material.entity.Material;
import com.jeeplus.modules.test.information.material.service.MaterialService;
import com.jeeplus.modules.test.information.service.InformationService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import com.google.common.collect.Lists;
import com.jeeplus.common.utils.DateUtils;
import com.jeeplus.common.json.AjaxJson;
import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.web.BaseController;
import com.jeeplus.common.utils.StringUtils;
import com.jeeplus.common.utils.excel.ExportExcel;
import com.jeeplus.common.utils.excel.ImportExcel;
import com.jeeplus.modules.test.onetomany.dialog.entity.TestDataMain1;

/**
 * 物料详情Controller
 * @author
 * @version
 */
@Controller
@RequestMapping(value = "${adminPath}/test/information/material")
public class MaterialController extends BaseController {

	@Autowired
	private MaterialService materialService;
	
	@ModelAttribute
	public Material get(@RequestParam(required=false) String id) {
		Material entity = null;
		if (StringUtils.isNotBlank(id)){
			entity = materialService.get(id);
		}
		if (entity == null){
			entity = new Material();
		}
		return entity;
	}
	
	/**
	 * 物料详情列表页
	 */
	//@RequiresPermissions("test:information:information:list")
	@RequestMapping(value = {"list", ""})
	public String list(Material material, Model model) {
		model.addAttribute("materialList", material);
		return "modules/test/information/material/materialList";
	}


	/**
	 * 物料详情列表数据
	 */
	@ResponseBody
	//@RequiresPermissions("test:onetomany:dialog:testDataMain1:list")
	@RequestMapping(value = "data")
	public Map<String, Object> data(Material material, HttpServletRequest request, HttpServletResponse response, Model model) {
		Page<Material> page = materialService.findPage(new Page<Material>(request, response), material);
		return getBootstrapData(page);
	}

	@RequestMapping(value = "form")
	public String form(Information information, Model model) {
		model.addAttribute("Information", information);
		return "modules/test/information/material/materialForm";
	}
/*
	*/
/**
	 * 导出excel文件
	 *//*

	@ResponseBody
	//@RequiresPermissions("test:onetomany:dialog:testDataMain1:export")
    @RequestMapping(value = "export")
    public AjaxJson exportFile(Material material, HttpServletRequest request, HttpServletResponse response) {
		AjaxJson j = new AjaxJson();
		try {
            String fileName = "票务代理"+DateUtils.getDate("yyyyMMddHHmmss")+".xlsx";
            Page<Material> page = materialService.findPage(new Page<Material>(request, response, -1), material);
    		new ExportExcel("票务代理", TestDataMain1.class).setDataList(page.getList()).write(response, fileName).dispose();
    		j.setSuccess(true);
    		j.setMsg("导出成功！");
    		return j;
		} catch (Exception e) {
			j.setSuccess(false);
			j.setMsg("导出票务代理记录失败！失败信息："+e.getMessage());
		}
			return j;
    }
*/

	

	
/*	*//**
	 * 下载导入物料详情数据模板
	 *//*
	@ResponseBody
	@RequiresPermissions("test:onetomany:dialog:testDataMain1:import")
    @RequestMapping(value = "import/template")
     public AjaxJson importFileTemplate(HttpServletResponse response) {
		AjaxJson j = new AjaxJson();
		try {
            String fileName = "票务代理数据导入模板.xlsx";
    		List<TestDataMain1> list = Lists.newArrayList(); 
    		new ExportExcel("票务代理数据", TestDataMain1.class, 1).setDataList(list).write(response, fileName).dispose();
    		return null;
		} catch (Exception e) {
			j.setSuccess(false);
			j.setMsg( "导入模板下载失败！失败信息："+e.getMessage());
		}
		return j;
    }*/
	

}