/**
 * Copyright &copy; 2015-2020 <a href="http://www.jeeplus.org/">JeePlus</a> All rights reserved.
 */
package com.jeeplus.modules.test.information.service;

import java.util.List;

import com.jeeplus.modules.test.information.entity.Information;
import com.jeeplus.modules.test.information.mapper.InformationMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.service.CrudService;
import com.jeeplus.common.utils.StringUtils;
import com.jeeplus.modules.test.onetomany.dialog.entity.TestDataMain1;
import com.jeeplus.modules.test.onetomany.dialog.mapper.TestDataMain1Mapper;
import com.jeeplus.modules.test.onetomany.dialog.entity.TestDataChild11;
import com.jeeplus.modules.test.onetomany.dialog.mapper.TestDataChild11Mapper;
import com.jeeplus.modules.test.onetomany.dialog.entity.TestDataChild12;
import com.jeeplus.modules.test.onetomany.dialog.mapper.TestDataChild12Mapper;
import com.jeeplus.modules.test.onetomany.dialog.entity.TestDataChild13;
import com.jeeplus.modules.test.onetomany.dialog.mapper.TestDataChild13Mapper;

import javax.annotation.Resource;

/**
 * 项目管理Service
 * @author
 * @version
 */
@Service
@Transactional(readOnly = true)
public class InformationService extends CrudService<InformationMapper, Information> {

	@Autowired
	private InformationMapper informationMapper;

	public Information get(String id) {
		Information information = super.get(id);
		return information;
	}

	public List<Information> findList(Information information) {
		return super.findList(information);
	}

	public List<Information> findAllList(Information entity) {
		return super.findAllList(entity);
	}

	public Page<Information> findPage(Page<Information> page, Information entity) {
		return super.findPage(page, entity);
	}

	@Transactional(readOnly = false)
	public void save(Information entity) {
		super.save(entity);
	}

	public  List<Information> findAllInformationList() {
		return informationMapper.findAllInformationList();
	}

	@Transactional(readOnly = false)
	public int updateInformationDate(Information information) {
		return informationMapper.updateInformationDate(information);
	}

	public Information findInformationByID(Information information) {
		return informationMapper.findInformationByID(information);
	}
}